uniform mat4 uMVPMatrix; //总变换矩阵
attribute vec3 aPosition;  //顶点位置
attribute vec2 aTexCoor;    //顶点纹理坐标

varying vec2 vTextureCoord;  //用于传递给片元着色器的变量
varying vec2 vTextureRate;  //自定义参数.

uniform vec4 drop0_data0;
uniform vec4 drop0_data1;
uniform vec4 drop1_data0;
uniform vec4 drop1_data1;
uniform vec4 drop2_data0;
uniform vec4 drop2_data1;
uniform vec4 drop3_data0;
uniform vec4 drop3_data1;
uniform vec4 drop4_data0;
uniform vec4 drop4_data1;
uniform vec4 drop5_data0;
uniform vec4 drop5_data1;

uniform vec4 drop6_data0;
uniform vec4 drop6_data1;
uniform vec4 drop7_data0;
uniform vec4 drop7_data1;
uniform vec4 drop8_data0;
uniform vec4 drop8_data1;
uniform vec4 drop9_data0;
uniform vec4 drop9_data1;
/*
*/

const float zero = 0.0;
const float pi = 3.1415926;
const float T = 6.0;
const float e = 2.71828;
float notchangedW = 25.0;
float timeSmallerFactor = 0.5;
float miniDistance = 0.003;//0.003 
//bool useZhenshi = false;
float veryLittleValue = 0.0001;
vec2 getA(vec4 data0,vec4 data1, vec3 pos) {
    /*
    if (data1.x<zero) {
        return zero;
    }
      float t = data0.z;
      vec2 delta = vec2(data0.x,data0.y) - vec2(pos.x,pos.y);
      float dist = length(delta);
      float originA = data1.x;
      float theta = data1.y;
      float u = data1.z;
      float w = data1.w;
      */
      vec2 resultVec = vec2(0.0,0.0);
      vec2 normalizedDirection = normalize(vec2(data0.x,data0.y) - vec2(pos.x,pos.y));
      float dist = length(vec2(data0.x,data0.y) - vec2(pos.x,pos.y));
 //     if (abs(dist) < data0.w && abs(dist)>data0.w-2.0*data1.z*T) {//圆心不要动.
      if (abs(dist) < data0.w && abs(dist)>veryLittleValue) {//圆心不要动.
//          float timepast = timeSmallerFactor*t-dist/u;
          float timepast = timeSmallerFactor*data0.z-dist/data1.z;
 //         float A = originA*(1.0-dist/data0.w)*pow(e,-1.0*theta*(timepast));
 //         float A = data1.x*(1.0-dist/data0.w)*pow(e,-1.0*data1.y*(timepast));
 //         return A*cos(data1.w*timepast+initXiangwei);
 
 //一定要外强内弱.才好看.
// resultVec = normalizedDirection*(data1.x*(pow(e,0.8*(dist))/4.0)*pow(e,-1.0*data1.y*(timepast))*cos(data1.w*timepast+pi*1.0/2.0));
 if (abs(dist)>data0.w-0.14) {//最外围处理,防止毛边.
   //return resultVec/4.0;
 } 
 resultVec = normalizedDirection*(data1.x*(1.0-dist/data0.w)*pow(e,-1.0*data1.y*(timepast))*cos(data1.w*timepast+pi*1.0/2.0));
          
      }
      return resultVec;
}
vec2 getTotalA(vec3 pos) {
    vec2 totalA = vec2(0.0,0.0);
     totalA+= getA(drop0_data0,drop0_data1,pos);
     totalA+= getA(drop1_data0,drop1_data1,pos);
     totalA+= getA(drop2_data0,drop2_data1,pos);
     totalA+= getA(drop3_data0,drop3_data1,pos);
     totalA+= getA(drop4_data0,drop4_data1,pos);
     totalA+= getA(drop5_data0,drop5_data1,pos);
     
     totalA+= getA(drop6_data0,drop6_data1,pos);
     totalA+= getA(drop7_data0,drop7_data1,pos);
     totalA+= getA(drop8_data0,drop8_data1,pos);
     /*
     totalA+= getA(drop9_data0,drop9_data1,pos);
     */
    return totalA;
}

vec3 doEffect(vec3 pos) {
    vec3 result = vec3(pos.x,pos.y,notchangedW);
    vec3 leftOne = vec3(pos.x-miniDistance,pos.y,pos.z);
  vec3 topOne = vec3(pos.x,pos.y+miniDistance,pos.z);
  
//  vec3 rightOne = vec3(pos.x+miniDistance,pos.y,pos.z);
 // vec3 bottomOne = vec3(pos.x,pos.y-miniDistance,pos.z);
  
  float leftA = zero;
  float topA = zero;
  
//  float rightA = 0.0;
//  float bottomA = 0.0;
/*
  bool thisPositionAffect = false;
  leftA = getTotalA(leftOne);
  if (abs(leftA)>veryLittleValue) {
    thisPositionAffect = true;
  }
  topA = getTotalA( topOne);
  if (abs(topA)>veryLittleValue) {
    thisPositionAffect = true;
  }  
  */
  
  vec2 currA = getTotalA( pos);
  if (length(currA)>veryLittleValue) {
      float maxX = 2.94*1.5;
      if (abs(currA.x)>maxX) {
        currA.x = maxX*sign(currA.x);
      }
      if (abs(currA.y)>maxX) {
        currA.y = maxX*sign(currA.y);
      }
  // currA.x = log(abs(currA.x))*sign(currA.x);
  // currA.y = log(abs(currA.y))*sign(currA.y);
    //thisPositionAffect = true;
      result.x+= (currA.x)*0.03;
      result.y+= (currA.y)*0.03/(0.5/0.3125);
  //    result.x+= (currA.x)*0.05;
  //    result.y+= (currA.y)*0.05/(0.5/0.3125);
  //    result.x+= (-1.0*(currA.x)*currA.x+maxX)*0.2;
  //    result.y+= (-1.0*(currA.y)*currA.y+maxX)*0.2/(0.5/0.3125);
  //   result.x+= (pow(e,-1.0*currA.x)-1.0)*0.05;
  //   result.y+= (pow(e,-1.0*currA.y)-1.0)*0.05/(0.5/0.3125);
  
    //  result.x+= (sin(currA.x))*0.05;
    //  result.y+= (sin(currA.y))*0.05/(0.5/0.3125);
  }
 // result.z = (1.0+length(currA))/2.0;
  
      /*
  if (thisPositionAffect) {
    vec2 rightResult = getTotalA( rightOne);
      if (abs(rightResult.y-isAffectedValue)<0.001) {
        rightA = rightResult.x;
        thisPositionAffect = true;
      }     
      if (thisPositionAffect) {
          vec2 topResult = getTotalA( topOne);
          if (abs(topResult.y-isAffectedValue)<0.001) {
            topA = topResult.x;
            thisPositionAffect = true;
          }  
          if (thisPositionAffect) {
              vec2 bottomResult = getTotalA( bottomOne);
              if (abs(bottomResult.y-isAffectedValue)<0.001) {
                bottomA = bottomResult.x;
                thisPositionAffect = true;
              }            
          }          
      }
  }
  if (thisPositionAffect) {
   //   result.x+= (leftA-currA)*0.7;
  //    result.y+= (currA-topA)*0.7/(0.5/0.3125);
 //     result.x+= (leftA-rightA)*0.7;
 //     result.y+= (bottomA-topA)*0.7/(0.5/0.3125);
  }
          */
  return result;
}

/*
限制长度.
08-31 16:13:47.892: E/ES20_ERROR(19348): Could not compile shader 35633:
08-31 16:13:47.892: E/ES20_ERROR(19348): 0:1: F0003: Shader too long. This shader is 528 instruction words long, but
08-31 16:13:47.892: E/ES20_ERROR(19348):             Mali-400 GP only supports up to 512 instruction words.
一次计算出,不算邻近点.把同时生效数提升.
*/
void main()     
{       
     vec3 result0 = doEffect(aPosition);
     if (abs(result0.z-notchangedW)>1.0){
        vTextureRate = vec2(1.0,result0.z);
     } else {
        vTextureRate = vec2(zero,zero);
     }
	gl_Position = uMVPMatrix * vec4(result0.x,result0.y,aPosition.z,1.0); //根据总变换矩阵计算此次绘制此顶点位置
    vTextureCoord = aTexCoor;//将接收的纹理坐标传递给片元着色器
}                       