uniform mat4 uMVPMatrix; //总变换矩阵
attribute vec3 aPosition;  //顶点位置
attribute vec2 aTexCoor;    //顶点纹理坐标

varying vec2 vTextureCoord;  //用于传递给片元着色器的变量
varying vec2 vTextureRate;  //自定义参数.

uniform vec4 drop0_data0;
uniform vec4 drop0_data1;
uniform vec4 drop1_data0;
uniform vec4 drop1_data1;
uniform vec4 drop2_data0;
uniform vec4 drop2_data1;
uniform vec4 drop3_data0;
uniform vec4 drop3_data1;
uniform vec4 drop4_data0;
uniform vec4 drop4_data1;
uniform vec4 drop5_data0;
uniform vec4 drop5_data1;

uniform vec4 drop6_data0;
uniform vec4 drop6_data1;
uniform vec4 drop7_data0;
uniform vec4 drop7_data1;
uniform vec4 drop8_data0;
uniform vec4 drop8_data1;
uniform vec4 drop9_data0;
uniform vec4 drop9_data1;


uniform vec4 lydrop0_data0;
uniform vec4 lydrop0_data1;
uniform vec4 lydrop1_data0;
uniform vec4 lydrop1_data1;
uniform vec4 lydrop2_data0;
uniform vec4 lydrop2_data1;
uniform vec4 lydrop3_data0;
uniform vec4 lydrop3_data1;
uniform vec4 lydrop4_data0;
uniform vec4 lydrop4_data1;
uniform vec4 lydrop5_data0;
uniform vec4 lydrop5_data1;

uniform vec4 lydrop6_data0;
uniform vec4 lydrop6_data1;
uniform vec4 lydrop7_data0;
uniform vec4 lydrop7_data1;
uniform vec4 lydrop8_data0;
uniform vec4 lydrop8_data1;
uniform vec4 lydrop9_data0;
uniform vec4 lydrop9_data1;
uniform vec4 lydrop10_data0;
uniform vec4 lydrop10_data1;
uniform vec4 lydrop11_data0;
uniform vec4 lydrop11_data1;

const float zero = 0.0;
const float pi = 3.1415926;
const float T = 6.0;
const float e = 2.71828;
float notchangedW = 25.0;
float timeSmallerFactor = 0.5;
float miniDistance = 0.003;//0.003 
//bool useZhenshi = false;
float veryLittleValue = 0.0001;
vec2 getA(vec4 data0,vec4 data1, vec3 pos) {
    /*
    if (data1.x<zero) {
        return zero;
    }
      float t = data0.z;
      vec2 delta = vec2(data0.x,data0.y) - vec2(pos.x,pos.y);
      float dist = length(delta);
      float originA = data1.x;
      float theta = data1.y;
      float u = data1.z;
      float w = data1.w;
      */
      vec2 resultVec = vec2(0.0,0.0);
     if (data1.x<0.0) {
        return resultVec;
    }
      vec2 normalizedDirection = normalize(vec2(data0.x,data0.y) - vec2(pos.x,pos.y));
      float dist = length(vec2(data0.x,data0.y) - vec2(pos.x,pos.y));
 //     if (abs(dist) < data0.w && abs(dist)>data0.w-2.0*data1.z*T) {//圆心不要动.
      if (abs(dist) < data0.w && abs(dist)>veryLittleValue) {//圆心不要动.
//          float timepast = timeSmallerFactor*t-dist/u;
          float timepast = timeSmallerFactor*data0.z-dist/data1.z;
 //         float A = originA*(1.0-dist/data0.w)*pow(e,-1.0*theta*(timepast));
 //         float A = data1.x*(1.0-dist/data0.w)*pow(e,-1.0*data1.y*(timepast));
 //         return A*cos(data1.w*timepast+initXiangwei);
 
 //一定要外强内弱.才好看.
// resultVec = normalizedDirection*(data1.x*(pow(e,0.8*(dist))/4.0)*pow(e,-1.0*data1.y*(timepast))*cos(data1.w*timepast+pi*1.0/2.0));
 if (abs(dist)>data0.w-0.14) {//最外围处理,防止毛边.
   //return resultVec/4.0;
 } 
 resultVec = normalizedDirection*(data1.x*(1.0-dist/data0.w)*pow(e,-1.0*data1.y*(timepast))*cos(data1.w*timepast+pi*1.0/2.0));
          
      }
      return resultVec;
}

float miniTwoInterval = 1.4;
float getRelaDist(vec4 data0,vec4 data1,vec4 enddata0,vec4 enddata1 ,vec3 pos,bool thisIsEnd) {
    float dist = 0.0;//default,not include.
    vec2 center = vec2(data0.x,data0.y);
    vec2 currPoint = vec2(pos.x,pos.y);
    vec2 endcenter = vec2(enddata0.x,enddata0.y);
    vec2 direction = endcenter-center;
    vec2 currDirection = currPoint-center;
    float twoPointInterval = length(direction);
    
    float betweenAngle = 0.0;
    if (abs(endcenter.x-center.x)<0.001) {
        if (endcenter.x>center.x) {
            betweenAngle = pi/2.0;
        } else {
            betweenAngle = -1.0*pi/2.0;
        }
    } else {
        betweenAngle = atan((endcenter.y-center.y)/(endcenter.x-center.x));
    }
    
    if (twoPointInterval<miniTwoInterval) {
        
        //beginPoint.x = -1.0*miniTwoInterval*cos(betweenAngle)+center.x;
        //beginPoint.y = -1.0*miniTwoInterval*sin(betweenAngle)+center.y;
        
        endcenter.x = miniTwoInterval*cos(betweenAngle)+center.x;
        endcenter.y = miniTwoInterval*sin(betweenAngle)+center.y;
    }
    if (betweenAngle<pi/2.0 && betweenAngle>0.0) {//available
        if (!thisIsEnd) {
          //  if (betweenAngle<pi/2.0 && betweenAngle>pi*0.8/4.0) {
            if (betweenAngle<pi/2.0 && betweenAngle>pi*1.1/4.0) {
                vec2 endDirection = currPoint-endcenter;
                dist = abs(length(currDirection))+abs(length(endDirection));
            }
        } else {
             vec2 endDirection = currPoint-endcenter;
            dist = abs(length(currDirection))+abs(length(endDirection));
        }
    }
    return dist;
}
float getBetweenAngle(vec2 a,vec2 b) {
    float result = 0.0;
    result = acos(dot(a,b)/length(a)/length(b));
    return result;
}
bool isPositionInArea(vec2 a,vec2 positionVec,float begin,float end) {
    bool result = false;
    float angle = getBetweenAngle(a,positionVec);
    if (angle>begin && angle<end) {
        result = true;
    }
    return result;
}
float getRelaDist2(vec4 data0,vec4 data1,vec4 enddata0,vec4 enddata1 ,vec3 pos,bool thisIsEnd) {
    float dist = 0.0;//default,not include.
    vec2 center = vec2(data0.x,data0.y);
    vec2 currPoint = vec2(pos.x,pos.y);
    vec2 endcenter = vec2(enddata0.x,enddata0.y);
    
    vec2 direction = endcenter-center;
    vec2 currDirection = endcenter-currPoint;
    float betweenAngle = 0.0;
    betweenAngle = getBetweenAngle(currDirection,direction);
    if (betweenAngle<pi/2.0 && betweenAngle>0.0) {//available
        
        if (!thisIsEnd) {
        
            if (betweenAngle<pi/4.0 && betweenAngle>pi*0.58/4.0) {
                if (length(currDirection)<1.0) {
                    dist = betweenAngle*0.2;
                }
            }
        } else {
            if (betweenAngle<pi/4.0 && betweenAngle>0.0) {
            if (length(currDirection)<1.0) {
            dist = betweenAngle*0.2;
            }
            }
        }
    }
    return dist;
}
vec2 rotateVec2(vec2 a ,float angle) {
    vec2 result = vec2(a.x*cos(angle)-a.y*sin(angle),a.x*sin(angle)+a.y*cos(angle));
    return result;
}
vec2 getNextPoint(vec2 begin,vec2 end,float rate) {
    vec2 result = vec2(0.0,0.0);
    float deltaX  = end.x-begin.x;
    float deltaY  = end.y-begin.y;
    result.x = begin.x+deltaX*rate;
    result.y = begin.y+deltaY*rate;
    
    return result;
}
bool test = true;
vec2 getLyA(vec4 data0,vec4 data1,vec4 enddata0,vec4 enddata1, vec3 pos,bool thisIsEnd) {
    vec2 resultVec = vec2(0.0,0.0);
    if (data1.x<0.0 || enddata1.x<0.0) {
        return resultVec;
    }
    vec2 center = vec2(data0.x,data0.y);
    vec2 currPoint = vec2(pos.x,pos.y);
    vec2 endcenter = vec2(enddata0.x,enddata0.y);
    
    float originA = data1.x;
      float theta = data1.y;
      float t = data0.z;
      float u = data1.z;
      float A = originA;
      
      float T = 24.0;//Lianyi
    float timeSmallerFactor = 0.5;
    float maxSpreadInterval =  1.7f;
    float rate = enddata0.w/timeSmallerFactor/maxSpreadInterval;
    //endcenter = getNextPoint(center,endcenter,rate);
    vec2 direction = endcenter-center;
    
    float minBetweenAngle = pi/15.0;
    vec2 rotateVecOne = rotateVec2(direction,-minBetweenAngle);
    vec2 rotateVecTwo = rotateVec2(direction,minBetweenAngle);
     vec2 finalDirection = vec2(0.0,0.0);
     //float dist = getRelaDist2(data0, data1, enddata0, enddata1, pos,thisIsEnd);
     float dist = 0.0;
     
     vec2 determineVec = rotateVec2(direction,(pi-minBetweenAngle)/2.0);
     vec2 determineVec2 = rotateVec2(direction,-(pi-minBetweenAngle)/2.0);
     
     float roundbetweenAngle = getBetweenAngle(currPoint-endcenter,direction);
     
     if (abs(roundbetweenAngle)<pi/2.0-minBetweenAngle) {//半圆区.
        finalDirection = currPoint-endcenter;
        dist = length(currPoint-endcenter);
     } else {
        bool inFirst = isPositionInArea(determineVec,currPoint-endcenter,0.0,(pi-minBetweenAngle)/2.0);
         bool inSecond= false;
         float betweenAngle = getBetweenAngle(currPoint-center,direction);
        if (abs(betweenAngle)<pi/2.7) {//射线
            if (inFirst) {
                //A!=0,B!=0
                
                finalDirection = vec2(rotateVecOne.y,-1.0*rotateVecOne.x);//fa
                float absLength1 = length(finalDirection);
                if (absLength1>0.01) {
                    dist = length(dot(endcenter-currPoint,finalDirection))/absLength1;
                }
            } else {
                 inSecond = isPositionInArea(determineVec2,currPoint-endcenter,0.0,(pi-minBetweenAngle)/2.0);
                 if (inSecond) {
                    finalDirection = vec2(rotateVecTwo.y,-1.0*rotateVecTwo.x);//fa
                    float absLength2 = length(finalDirection);
                    if (absLength2>0.01) {
                         dist = length(dot(currPoint-endcenter,finalDirection))/absLength2;
                    }
                 }
            }
        }
    }
      
      float maxTwoBetween = data0.w-0.0*u*T;
      if (abs(dist) <maxTwoBetween && dist>0.0 && abs(dist)>maxTwoBetween-0.5*u*T) {//圆心不要动.
  //    if (abs(dist) <maxTwoBetween && dist>0.0) {//圆心不要动.
          float timepast = timeSmallerFactor*data0.z-dist/data1.z;
          
          float A = originA*(1.0-dist/data0.w)*pow(e,-0.2*theta*(timepast));
          float w = data1.w;
         // float currAngle = w*timepast+pi*1.0/2.0;
          
          vec2 normalizedDirection = normalize(finalDirection);
          float currAngle = data1.w*timepast+pi*1.0/2.0;
          float yushu = mod(currAngle,2.0*pi);
          yushu =  currAngle - 2.0*pi*floor(currAngle/(2.0*pi));
          float finalA = (data1.x*(1.0-dist/data0.w)*pow(e,-1.0*data1.y*(timepast))*cos(currAngle));
          float pianyiX = 0.0;
          float pianyiY = 0.0;
          if (yushu<2.0*pi && yushu>pi) {//判断方向是否是反向.
             normalizedDirection.x = -normalizedDirection.x;
             normalizedDirection.y = -normalizedDirection.y;
          }
           resultVec = normalizedDirection*abs(finalA)*sin(currAngle)*1.2;
         // resultVec = normalizedDirection*finalA;
          
         // resultVec = normalizedDirection*A*cos(currAngle);
      }
      return resultVec;
}
vec2 getTotalA(vec3 pos) {
    vec2 totalA = vec2(0.0,0.0);
     totalA+= getA(drop0_data0,drop0_data1,pos);
     totalA+= getA(drop1_data0,drop1_data1,pos);
     totalA+= getA(drop2_data0,drop2_data1,pos);
     totalA+= getA(drop3_data0,drop3_data1,pos);
     totalA+= getA(drop4_data0,drop4_data1,pos);
     totalA+= getA(drop5_data0,drop5_data1,pos);
     
     totalA+= getA(drop6_data0,drop6_data1,pos);
     totalA+= getA(drop7_data0,drop7_data1,pos);
     totalA+= getA(drop8_data0,drop8_data1,pos);
     
     bool firstNull = false;
      bool secondNull = false;
      bool thirdNull = false;
      bool fourthNull = false;
      bool fifthNull = false;
      bool null6 = false;
      bool null7 = false;
      bool null8 = false;
      bool null9 = false;
      if (lydrop0_data1.x<0.0) {
            firstNull = true;
      }
      if (lydrop1_data1.x<0.0) {
      secondNull = true;
      }
      if (lydrop2_data1.x<0.0) {
      thirdNull = true;
      }
      if (lydrop3_data1.x<0.0) {
      fourthNull = true;
      }
      if (lydrop4_data1.x<0.0) {
      fifthNull = true;
      }
      if (lydrop5_data1.x<0.0) {
      null6 = true;
      }
      if (lydrop6_data1.x<0.0) {
      null7 = true;
      }
      /*
      if (lydrop7_data1.x<0.0) {
      null8 = true;
      }
      if (lydrop8_data1.x<0.0) {
      null9 = true;
      }
      */
      if (!firstNull && !secondNull) {
          totalA+= getLyA(lydrop0_data0,lydrop0_data1,lydrop1_data0,lydrop1_data1,pos,thirdNull);
      }
      
      if (!secondNull && !thirdNull) {
         totalA+= getLyA(lydrop1_data0,lydrop1_data1,lydrop2_data0,lydrop2_data1,pos,fourthNull);
      }
      
      if (!thirdNull && !fourthNull) {
         totalA+= getLyA(lydrop2_data0,lydrop2_data1,lydrop3_data0,lydrop3_data1,pos,fifthNull);
      }
      
      if (!fourthNull && !fifthNull) {
         totalA+= getLyA(lydrop3_data0,lydrop3_data1,lydrop4_data0,lydrop4_data1,pos,true);//数据为空则直接返回.
      }
      if (!fifthNull && !null6) {
         totalA+= getLyA(lydrop4_data0,lydrop4_data1,lydrop5_data0,lydrop5_data1,pos,true);//数据为空则直接返回.
      }
      if (!null6 && !null7) {
         totalA+= getLyA(lydrop5_data0,lydrop5_data1,lydrop6_data0,lydrop6_data1,pos,true);//数据为空则直接返回.
      }
    return totalA;
}

vec3 doEffect(vec3 pos) {
    vec3 result = vec3(pos.x,pos.y,notchangedW);
    vec3 leftOne = vec3(pos.x-miniDistance,pos.y,pos.z);
  vec3 topOne = vec3(pos.x,pos.y+miniDistance,pos.z);
  
//  vec3 rightOne = vec3(pos.x+miniDistance,pos.y,pos.z);
 // vec3 bottomOne = vec3(pos.x,pos.y-miniDistance,pos.z);
  
  float leftA = zero;
  float topA = zero;
  
//  float rightA = 0.0;
//  float bottomA = 0.0;
/*
  bool thisPositionAffect = false;
  leftA = getTotalA(leftOne);
  if (abs(leftA)>veryLittleValue) {
    thisPositionAffect = true;
  }
  topA = getTotalA( topOne);
  if (abs(topA)>veryLittleValue) {
    thisPositionAffect = true;
  }  
  */
  
  vec2 currA = getTotalA( pos);
  if (length(currA)>veryLittleValue) {
      float maxX = 0.3;
      if (abs(currA.x)>maxX) {
        currA.x = maxX*sign(currA.x);
      }
      if (abs(currA.y)>maxX) {
        currA.y = maxX*sign(currA.y);
      }
  // currA.x = log(abs(currA.x))*sign(currA.x);
  // currA.y = log(abs(currA.y))*sign(currA.y);
    //thisPositionAffect = true;
    float rateValue = 0.09;//0.07
     result.x+= (currA.x)*rateValue;
      result.y+= (currA.y)*rateValue/(0.5/0.3125);
      
      
  //    result.x+= (-1.0*(currA.x)*currA.x+maxX)*0.2;
  //    result.y+= (-1.0*(currA.y)*currA.y+maxX)*0.2/(0.5/0.3125);
  //   result.x+= (pow(e,-1.0*currA.x)-1.0)*0.05;
  //   result.y+= (pow(e,-1.0*currA.y)-1.0)*0.05/(0.5/0.3125);
  }
  
  if (test) {
  result.z = (1.0+length(currA))/2.0;
  }
      /*
  if (thisPositionAffect) {
    vec2 rightResult = getTotalA( rightOne);
      if (abs(rightResult.y-isAffectedValue)<0.001) {
        rightA = rightResult.x;
        thisPositionAffect = true;
      }     
      if (thisPositionAffect) {
          vec2 topResult = getTotalA( topOne);
          if (abs(topResult.y-isAffectedValue)<0.001) {
            topA = topResult.x;
            thisPositionAffect = true;
          }  
          if (thisPositionAffect) {
              vec2 bottomResult = getTotalA( bottomOne);
              if (abs(bottomResult.y-isAffectedValue)<0.001) {
                bottomA = bottomResult.x;
                thisPositionAffect = true;
              }            
          }          
      }
  }
  if (thisPositionAffect) {
   //   result.x+= (leftA-currA)*0.7;
  //    result.y+= (currA-topA)*0.7/(0.5/0.3125);
 //     result.x+= (leftA-rightA)*0.7;
 //     result.y+= (bottomA-topA)*0.7/(0.5/0.3125);
  }
          */
  return result;
}

/*
限制长度.
08-31 16:13:47.892: E/ES20_ERROR(19348): Could not compile shader 35633:
08-31 16:13:47.892: E/ES20_ERROR(19348): 0:1: F0003: Shader too long. This shader is 528 instruction words long, but
08-31 16:13:47.892: E/ES20_ERROR(19348):             Mali-400 GP only supports up to 512 instruction words.
一次计算出,不算邻近点.把同时生效数提升.
*/
void main()     
{       
     vec3 result0 = doEffect(aPosition);
     if (abs(result0.z-notchangedW)>1.0){
        vTextureRate = vec2(1.0,result0.z);
     } else {
        vTextureRate = vec2(zero,zero);
     }
	gl_Position = uMVPMatrix * vec4(result0.x,result0.y,aPosition.z,1.0); //根据总变换矩阵计算此次绘制此顶点位置
    vTextureCoord = aTexCoor;//将接收的纹理坐标传递给片元着色器
}                       